module Web
  VERSION = "1.0.0"  
  
  def Web::docroot= docroot
    Web::config[:docroot] = docroot
  end
  
  def Web::docroot
    Web::config[:docroot]
  end    

  class Config
    def initialize
      @config = {}
      @docs = {}
    end

    attr_reader :docs

    def [] (key)
      @config[key.to_s]
    end
    
    def []= (key, value)
      @config[key.to_s] = value
    end

    def describe( info={} )
      @docs.merge! info
    end

    def set( values={} )
      @config.merge! values
    end

    def method_missing( symbol, *args )
      if args.empty?
        self[symbol]
      else
        super( symbol, *args )
      end
    end
  end

  @@config = Config.new
  def Web.config
    @@config
  end

end
