require 'web'

module Web
  class FastCGIConnection < Connection
    def initialize( options = {} )
      fcgi = options[:fcgi]
      
      options[:out]            = fcgi.out
      options[:raw_post_data]  = fcgi.in
      options[:env]            = fcgi.env
      
      super( options )
    end
    
    def close
      super()
      options[:fcgi].finish if options[:fcgi]
      options[:fcgi] = nil
    end
  end
end

