# TODO: trace output is woefully broken

# TODO: formerly on Web::close:
# if Web::display_trace
#   trace_output
# end


module Web
  # Web::display_trace controls the display of trace variables
  @@display_trace = false
  class << self
    attr_accessor :display_trace
  end

  TRACE_STYLESHEET=<<-EOF
<style type="text/css">
span.tracecontent { background-color:white; color:black;font: 10pt verdana, arial; }
span.tracecontent table { font: 10pt verdana, arial; cellspacing:0; cellpadding:0; margin-bottom:25}
span.tracecontent tr.subhead { background-color:cccccc;}
span.tracecontent th { padding:0,3,0,3 }
span.tracecontent th.alt { background-color:black; color:white; padding:3,3,2,3; }
span.tracecontent td { padding:0,3,0,3 }
span.tracecontent tr.alt { background-color:eeeeee }
span.tracecontent h1 { font: 24pt verdana, arial; margin:0,0,0,0}
span.tracecontent h2 { font: 18pt verdana, arial; margin:0,0,0,0}
span.tracecontent h3 { font: 12pt verdana, arial; margin:0,0,0,0}
span.tracecontent th a { color:darkblue; font: 8pt verdana, arial; }
span.tracecontent a { color:darkblue;text-decoration:none }
span.tracecontent a:hover { color:darkblue;text-decoration:underline; }
span.tracecontent div.outer { width:90%; margin:15,15,15,15}
span.tracecontent table.viewmenu td { background-color:006699; color:white; padding:0,5,0,5; }
span.tracecontent table.viewmenu td.end { padding:0,0,0,0; }
span.tracecontent table.viewmenu a {color:white; font: 8pt verdana, arial; }
span.tracecontent table.viewmenu a:hover {color:white; font: 8pt verdana, arial; }
span.tracecontent a.tinylink {color:darkblue; font: 8pt verdana, arial;text-decoration:underline;}
span.tracecontent a.link {color:darkblue; text-decoration:underline;}
span.tracecontent div.buffer {padding-top:7; padding-bottom:17;}
span.tracecontent .small { font: 8pt verdana, arial }
span.tracecontent table td { padding-right:20 }
span.tracecontent table td.nopad { padding-right:5 }
</style>
EOF

  class Connection
    def Connection.trace_output_template
	    template = <<-EOF
<div>
<h1>Request Details</h1><br>
<table cellspacing="0" cellpadding="0" border="1" style="width:100%;border-collapse:collapse;">
<tr>
  <th class="alt" align="Left" colspan=2><h3><b>Request Parameters</b></h3></th></tr>
  <narf:foreach from=parameters item=parameter>
    <tr><th width=150>{$parameter.key}</th><td>{$parameter.value}</td></tr>
  </narf:foreach>
</table>
<br>
<table cellspacing="0" cellpadding="0" border="1" style="width:100%;border-collapse:collapse;">
  <tr><th class="alt" align="Left" colspan=2><h3><b>Cookies</b></h3></th></tr>
  <narf:foreach from=cookies item=cookie>
    <tr><th  width=150>{$cookie.key}</th><td>{$cookie.value}</td></tr>
  </narf:foreach>
</table>
<br>
<table cellspacing="0" cellpadding="0" border="1" style="width:100%;border-collapse:collapse;">
  <tr><th class="alt" align="Left" colspan=2><h3><b>Session</b></h3></th></tr>
  <narf:foreach from=session item=sessionitem>
    <tr><th  width=150>{$sessionitem.key}</th><td>{$sessionitem.value}</td></tr>
 </table>
</div>
EOF
    end
  end
end

