require 'rubygems'
require 'rubygems/installer'

module Gem
  class Specification
    def at_install( &aproc )
      @at_install ||= [ ]
      @at_install.push aproc
    end

    def install_hooks
      @at_install ||= [ ]
    end
  end

  class Installer
    alias :original_install :install
    
    def install(force=false, install_dir=Gem.dir, install_stub=false)
      self.original_install( force, install_dir, install_stub )
      format = Gem::Format.from_file_by_path(@gem)
      spec = format.spec
      spec.install_hooks.each  do |aproc|
        aproc.call
      end
    end
  end
end

spec = Gem::Specification.new do |s|
  #### Basic information.
  s.name = 'narf'
  s.version = "0.7.3"
  s.summary = <<-EOF
NARF is a replacement for and derivative of the Ruby CGI library. It exists to trivialize web development .
EOF
  s.description = <<-EOF
These are the basic goals of narf:

* To make it easy, really easy to write Web applications.
* To make it easy, really easy to test them.
* To run everywhere

EOF

  #### Which files are to be included in this gem?  Everything!  (Except CVS directories.)
  s.files = Dir.glob("**/*").delete_if { |item|
    item.include?("CVS") || item.include?("svn")
  }

  #### Load-time details: library and application (you will need one or both).

  s.require_path = 'lib'                         # Use these for libraries.
  s.autorequire = 'web'

	s.at_install {
    raise "hell"
	  Kernel.puts "hi patrick"
  }

  #### Documentation and testing.

  s.has_rdoc = true
  #s.test_suite_file = "build.rb test"

  #### Author and project details.

  s.author = "Patrick May"
  s.email = "narf@hexane.org"
  s.homepage = "http://www.narf-lib.org"
  s.rubyforge_project = "narf"
end 

if $0==__FILE__
  Gem::manage_gems
  Gem::Builder.new(spec).build
end
