#!/usr/bin/ruby

NARF_SVN_SERVER = "http://svn.narf-lib.org/svn/narf"

cwd = Dir.pwd

require 'ftools'

if ARGV.size != 3
  puts "Usage: ruby scripts/makedist.rb username password 1.2.3"
  puts ""
  puts " * username and password are your narf svn credentials"
  puts " * 1.2.3 is the narf release number" 
  exit
end

username = ARGV[0]
password = ARGV[1]
version  = ARGV[2]

versiontag = "VERSION_#{version.gsub(/\./,'_')}"

system( "rm narf*.gem" )
gemspec = File.open( "narf.gemspec", "r" ) { |f|
  f.read
}
gemspec.sub(/s.version = "\d.\d.\d"/,
            "s.version = \"#{version}\"" )
File.open("narf.gemspec", "w" ) { |f|
  f.write gemspec
}

svn = "svn --username #{username} --password #{ password }"
system( "#{svn} log > ChangeLog")
system( "#{svn} commit -m \"Preparing for #{version} release\"" )
system( "#{svn} delete #{NARF_SVN_SERVER}/releases/#{versiontag} -m \"Deleted any existing release branch for #{version}\"" )
system( "#{svn} copy #{NARF_SVN_SERVER}/trunk/ #{NARF_SVN_SERVER}/releases/#{versiontag} -m \"Created release branch for #{version}\"" )

Dir.mkdir( "../dist" ) unless( File.exists? "../dist" )
system("rm -Rf ../dist/narf-#{version}")
Dir.chdir("../dist")

system("#{svn} export #{NARF_SVN_SERVER}/releases/#{versiontag} narf-#{version}" )

system("cd narf-#{version}; ruby build.rb rdoc");
system("tar cvzf narf-#{version}.tgz narf-#{version}")

# update sourcefoge
system("ncftpput upload.sourceforge.net incoming narf-#{version}.tgz")

# build gems
Dir.chdir(cwd)
system("gem build narf.gemspec")
system("ncftpput upload.sourceforge.net incoming narf-#{version}.gem")

# update raa

# update ruby-forge




