class TestWebConfig < Test::Unit::TestCase
  def setup
    @old_config = Web::config
    Web::module_eval do
      @@config = Web::Config.new
    end
  end

  def teardown
    c = @old_config
    Web::module_eval do
      @@config = c
    end
  end

  def test_preferences
    Web::config.set("random_pref" => "random value",
                    "another_pref" => "another value")
    assert_equal( "random value", Web::config::random_pref )
    assert_equal( "random value", Web::config["random_pref"] )
    assert_equal( "another value", Web::config::another_pref )
    assert_equal( "another value", Web::config["another_pref"] )
  end

  def test_docs
    assert_equal( nil, Web::config["random_pref"] )
    Web::config::describe( :random_pref => "This is a test" )
    assert_equal( "This is a test", Web::config::docs[:random_pref] )
  end
  
end
