class TestMimeType < Test::Unit::TestCase
  def test_all_mime_types_work
    # this is somewhat circular.
    Web::Mime.mime_types.each { |extension, mimetype|
      assert_equal( mimetype,
		    Web::Mime.get_mime_type( "../some/directory/file." + extension ) )
    }
  end

  def test_some_standard_mimetypes
    assert_equal( "text/plain",               Web::Mime.get_mime_type( "file.txt"  ) )
    assert_equal( "text/html",                Web::Mime.get_mime_type( "file.html" ) )
    assert_equal( "image/jpeg",               Web::Mime.get_mime_type( "file.jpg"  ) )
    assert_equal( "application/zip",          Web::Mime.get_mime_type( "file.zip"  ) )
    assert_equal( "application/octet-stream", Web::Mime.get_mime_type( "file.exe"  ) )

    assert_equal( "text/plain",               Web::get_mime_type( "file.txt"  ) )
    assert_equal( "text/html",                Web::get_mime_type( "file.html" ) )
    assert_equal( "image/jpeg",               Web::get_mime_type( "file.jpg"  ) )
    assert_equal( "application/zip",          Web::get_mime_type( "file.zip"  ) )
    assert_equal( "application/octet-stream", Web::get_mime_type( "file.exe"  ) )
  end
end
