  class TestUpload < Test::Unit::TestCase
    attr_reader :original_filename, :content_type, :test_file, :move_to
    def setup
      @test_file         = "test/web/testfiles/fallow_keep.png.450x450.2005-07-24.jpg"
      @original_filename = "c:\\workspace\\fallow_keep.png.450x450.2005-07-24.jpg"
      @content_type      = "image/png"
      @move_to           = "test/web/testfiles/moved_fallow_keep.jpg"
    end
    
    def test_initialize
      File.open( test_file ) { |file|
        upload = Web::Upload.new( file, content_type, original_filename )
        
        assert_equal(   content_type,      upload.content_type      )
        assert_equal(   original_filename, upload.original_filename )
      }
    end
    
    def test_initialize_with_filename
      upload = Web::Upload.new( test_file, content_type, original_filename )
      
      assert_equal( File.open( test_file, "r" ) { |f| f.read }, upload.read )
    end
    
    def test_read_open_and_write_file
      expected_contents = File.open( test_file, "r" ) { |f| f.read }

      upload = Web::Upload.new( test_file, content_type, original_filename )
      
      assert_equal( expected_contents, upload.read )

      upload.open{ |io|
        assert_equal( expected_contents, io.read )
      }

      begin
        upload.save( move_to )
        File.open( move_to, "r" ) { |io|
          assert_equal( expected_contents, io.read )
        }
      ensure
        File.delete( move_to )
      end
    end
  end
